# RUN: llvm-mc -arch=mips -show-encoding -mcpu=mips1 < %s | FileCheck %s
# RUN: llvm-mc -arch=mips -show-encoding -mcpu=mips64 < %s | FileCheck %s

sge   $4, $5
# CHECK: slt  $4, $4, $5        # encoding: [0x00,0x85,0x20,0x2a]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sge   $4, $5, $6
# CHECK: slt   $4, $5, $6       # encoding: [0x00,0xa6,0x20,0x2a]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sge   $4, 16
# CHECK: slti  $4, $4, 16       # encoding: [0x28,0x84,0x00,0x10]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sge   $4, $5, 16
# CHECK: slti  $4, $5, 16       # encoding: [0x28,0xa4,0x00,0x10]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sge   $4, $5, 0x10000
# CHECK: lui   $4, 1            # encoding: [0x3c,0x04,0x00,0x01]
# CHECK: slt   $4, $5, $4       # encoding: [0x00,0xa4,0x20,0x2a]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sgeu  $4, $5
# CHECK: sltu  $4, $4, $5       # encoding: [0x00,0x85,0x20,0x2b]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sgeu  $4, $5, $6
# CHECK: sltu  $4, $5, $6       # encoding: [0x00,0xa6,0x20,0x2b]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sgeu  $4, 16
# CHECK: sltiu $4, $4, 16       # encoding: [0x2c,0x84,0x00,0x10]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sgeu  $4, $5, 16
# CHECK: sltiu $4, $5, 16       # encoding: [0x2c,0xa4,0x00,0x10]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sgeu  $4, $5, 0x10000
# CHECK: lui   $4, 1            # encoding: [0x3c,0x04,0x00,0x01]
# CHECK: sltu  $4, $5, $4       # encoding: [0x00,0xa4,0x20,0x2b]
# CHECK: xori  $4, $4, 1        # encoding: [0x38,0x84,0x00,0x01]
sge   $4, 0x10000
# CHECK: lui  $1, 1             # encoding: [0x3c,0x01,0x00,0x01]
# CHECK: slt  $4, $4, $1        # encoding: [0x00,0x81,0x20,0x2a]
# CHECK: xori $4, $4, 1         # encoding: [0x38,0x84,0x00,0x01]
sgeu  $4, 0x10000
# CHECK: lui  $1, 1             # encoding: [0x3c,0x01,0x00,0x01]
# CHECK: sltu $4, $4, $1        # encoding: [0x00,0x81,0x20,0x2b]
# CHECK: xori $4, $4, 1         # encoding: [0x38,0x84,0x00,0x01]
