// RUN: llvm-mc -triple i386-unknown-unknown -x86-asm-syntax=intel -output-asm-variant=1 --show-encoding %s | FileCheck %s

// CHECK:      aesdec128kl xmm2, [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdd,0x94,0xf4,0x00,0x00,0x00,0x10]
               aesdec128kl xmm2, [esp + 8*esi + 268435456]

// CHECK:      aesdec128kl xmm2, [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdd,0x94,0x87,0x23,0x01,0x00,0x00]
               aesdec128kl xmm2, [edi + 4*eax + 291]

// CHECK:      aesdec128kl xmm2, [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdd,0x10]
               aesdec128kl xmm2, [eax]

// CHECK:      aesdec128kl xmm2, [2*ebp - 1536]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdd,0x14,0x6d,0x00,0xfa,0xff,0xff]
               aesdec128kl xmm2, [2*ebp - 1536]

// CHECK:      aesdec128kl xmm2, [ecx + 6096]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdd,0x91,0xd0,0x17,0x00,0x00]
               aesdec128kl xmm2, [ecx + 6096]

// CHECK:      aesdec128kl xmm2, [edx - 6144]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdd,0x92,0x00,0xe8,0xff,0xff]
               aesdec128kl xmm2, [edx - 6144]

// CHECK:      aesdec256kl xmm2, [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdf,0x94,0xf4,0x00,0x00,0x00,0x10]
               aesdec256kl xmm2, [esp + 8*esi + 268435456]

// CHECK:      aesdec256kl xmm2, [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdf,0x94,0x87,0x23,0x01,0x00,0x00]
               aesdec256kl xmm2, [edi + 4*eax + 291]

// CHECK:      aesdec256kl xmm2, [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdf,0x10]
               aesdec256kl xmm2, [eax]

// CHECK:      aesdec256kl xmm2, [2*ebp - 2048]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdf,0x14,0x6d,0x00,0xf8,0xff,0xff]
               aesdec256kl xmm2, [2*ebp - 2048]

// CHECK:      aesdec256kl xmm2, [ecx + 8128]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdf,0x91,0xc0,0x1f,0x00,0x00]
               aesdec256kl xmm2, [ecx + 8128]

// CHECK:      aesdec256kl xmm2, [edx - 8192]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdf,0x92,0x00,0xe0,0xff,0xff]
               aesdec256kl xmm2, [edx - 8192]

// CHECK:      aesenc128kl xmm2, [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0x94,0xf4,0x00,0x00,0x00,0x10]
               aesenc128kl xmm2, [esp + 8*esi + 268435456]

// CHECK:      aesenc128kl xmm2, [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0x94,0x87,0x23,0x01,0x00,0x00]
               aesenc128kl xmm2, [edi + 4*eax + 291]

// CHECK:      aesenc128kl xmm2, [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0x10]
               aesenc128kl xmm2, [eax]

// CHECK:      aesenc128kl xmm2, [2*ebp - 1536]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0x14,0x6d,0x00,0xfa,0xff,0xff]
               aesenc128kl xmm2, [2*ebp - 1536]

// CHECK:      aesenc128kl xmm2, [ecx + 6096]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0x91,0xd0,0x17,0x00,0x00]
               aesenc128kl xmm2, [ecx + 6096]

// CHECK:      aesenc128kl xmm2, [edx - 6144]
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0x92,0x00,0xe8,0xff,0xff]
               aesenc128kl xmm2, [edx - 6144]

// CHECK:      aesenc256kl xmm2, [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xde,0x94,0xf4,0x00,0x00,0x00,0x10]
               aesenc256kl xmm2, [esp + 8*esi + 268435456]

// CHECK:      aesenc256kl xmm2, [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xde,0x94,0x87,0x23,0x01,0x00,0x00]
               aesenc256kl xmm2, [edi + 4*eax + 291]

// CHECK:      aesenc256kl xmm2, [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xde,0x10]
               aesenc256kl xmm2, [eax]

// CHECK:      aesenc256kl xmm2, [2*ebp - 2048]
// CHECK: encoding: [0xf3,0x0f,0x38,0xde,0x14,0x6d,0x00,0xf8,0xff,0xff]
               aesenc256kl xmm2, [2*ebp - 2048]

// CHECK:      aesenc256kl xmm2, [ecx + 8128]
// CHECK: encoding: [0xf3,0x0f,0x38,0xde,0x91,0xc0,0x1f,0x00,0x00]
               aesenc256kl xmm2, [ecx + 8128]

// CHECK:      aesenc256kl xmm2, [edx - 8192]
// CHECK: encoding: [0xf3,0x0f,0x38,0xde,0x92,0x00,0xe0,0xff,0xff]
               aesenc256kl xmm2, [edx - 8192]

// CHECK:      encodekey128 ecx, ecx
// CHECK: encoding: [0xf3,0x0f,0x38,0xfa,0xc9]
               encodekey128 ecx, ecx

// CHECK:      encodekey256 ecx, ecx
// CHECK: encoding: [0xf3,0x0f,0x38,0xfb,0xc9]
               encodekey256 ecx, ecx

// CHECK:      loadiwkey xmm2, xmm3
// CHECK: encoding: [0xf3,0x0f,0x38,0xdc,0xd3]
               loadiwkey xmm2, xmm3

// CHECK:      aesdecwide128kl [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x8c,0xf4,0x00,0x00,0x00,0x10]
               aesdecwide128kl [esp + 8*esi + 268435456]

// CHECK:      aesdecwide128kl [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x8c,0x87,0x23,0x01,0x00,0x00]
               aesdecwide128kl [edi + 4*eax + 291]

// CHECK:      aesdecwide128kl [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x08]
               aesdecwide128kl [eax]

// CHECK:      aesdecwide128kl [2*ebp - 1536]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x0c,0x6d,0x00,0xfa,0xff,0xff]
               aesdecwide128kl [2*ebp - 1536]

// CHECK:      aesdecwide128kl [ecx + 6096]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x89,0xd0,0x17,0x00,0x00]
               aesdecwide128kl [ecx + 6096]

// CHECK:      aesdecwide128kl [edx - 6144]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x8a,0x00,0xe8,0xff,0xff]
               aesdecwide128kl [edx - 6144]

// CHECK:      aesdecwide256kl [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x9c,0xf4,0x00,0x00,0x00,0x10]
               aesdecwide256kl [esp + 8*esi + 268435456]

// CHECK:      aesdecwide256kl [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x9c,0x87,0x23,0x01,0x00,0x00]
               aesdecwide256kl [edi + 4*eax + 291]

// CHECK:      aesdecwide256kl [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x18]
               aesdecwide256kl [eax]

// CHECK:      aesdecwide256kl [2*ebp - 2048]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x1c,0x6d,0x00,0xf8,0xff,0xff]
               aesdecwide256kl [2*ebp - 2048]

// CHECK:      aesdecwide256kl [ecx + 8128]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x99,0xc0,0x1f,0x00,0x00]
               aesdecwide256kl [ecx + 8128]

// CHECK:      aesdecwide256kl [edx - 8192]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x9a,0x00,0xe0,0xff,0xff]
               aesdecwide256kl [edx - 8192]

// CHECK:      aesencwide128kl [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x84,0xf4,0x00,0x00,0x00,0x10]
               aesencwide128kl [esp + 8*esi + 268435456]

// CHECK:      aesencwide128kl [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x84,0x87,0x23,0x01,0x00,0x00]
               aesencwide128kl [edi + 4*eax + 291]

// CHECK:      aesencwide128kl [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x00]
               aesencwide128kl [eax]

// CHECK:      aesencwide128kl [2*ebp - 1536]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x04,0x6d,0x00,0xfa,0xff,0xff]
               aesencwide128kl [2*ebp - 1536]

// CHECK:      aesencwide128kl [ecx + 6096]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x81,0xd0,0x17,0x00,0x00]
               aesencwide128kl [ecx + 6096]

// CHECK:      aesencwide128kl [edx - 6144]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x82,0x00,0xe8,0xff,0xff]
               aesencwide128kl [edx - 6144]

// CHECK:      aesencwide256kl [esp + 8*esi + 268435456]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x94,0xf4,0x00,0x00,0x00,0x10]
               aesencwide256kl [esp + 8*esi + 268435456]

// CHECK:      aesencwide256kl [edi + 4*eax + 291]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x94,0x87,0x23,0x01,0x00,0x00]
               aesencwide256kl [edi + 4*eax + 291]

// CHECK:      aesencwide256kl [eax]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x10]
               aesencwide256kl [eax]

// CHECK:      aesencwide256kl [2*ebp - 2048]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x14,0x6d,0x00,0xf8,0xff,0xff]
               aesencwide256kl [2*ebp - 2048]

// CHECK:      aesencwide256kl [ecx + 8128]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x91,0xc0,0x1f,0x00,0x00]
               aesencwide256kl [ecx + 8128]

// CHECK:      aesencwide256kl [edx - 8192]
// CHECK: encoding: [0xf3,0x0f,0x38,0xd8,0x92,0x00,0xe0,0xff,0xff]
               aesencwide256kl [edx - 8192]
