# NOTE: Assertions have been autogenerated by utils/update_mca_test_checks.py
# RUN: llvm-mca -mtriple=x86_64-unknown-unknown -mcpu=atom -instruction-tables < %s | FileCheck %s

addsubpd  %xmm0, %xmm2
addsubpd  (%rax),  %xmm2

addsubps  %xmm0, %xmm2
addsubps  (%rax), %xmm2

haddpd    %xmm0, %xmm2
haddpd    (%rax), %xmm2

haddps    %xmm0, %xmm2
haddps    (%rax), %xmm2

hsubpd    %xmm0, %xmm2
hsubpd    (%rax), %xmm2

hsubps    %xmm0, %xmm2
hsubps    (%rax), %xmm2

lddqu     (%rax), %xmm2

monitor

movddup   %xmm0, %xmm2
movddup   (%rax), %xmm2

movshdup  %xmm0, %xmm2
movshdup  (%rax), %xmm2

movsldup  %xmm0, %xmm2
movsldup  (%rax), %xmm2

mwait

# CHECK:      Instruction Info:
# CHECK-NEXT: [1]: #uOps
# CHECK-NEXT: [2]: Latency
# CHECK-NEXT: [3]: RThroughput
# CHECK-NEXT: [4]: MayLoad
# CHECK-NEXT: [5]: MayStore
# CHECK-NEXT: [6]: HasSideEffects (U)

# CHECK:      [1]    [2]    [3]    [4]    [5]    [6]    Instructions:
# CHECK-NEXT:  3      6     5.00                        addsubpd	%xmm0, %xmm2
# CHECK-NEXT:  4      7     6.00    *                   addsubpd	(%rax), %xmm2
# CHECK-NEXT:  1      5     1.00                        addsubps	%xmm0, %xmm2
# CHECK-NEXT:  1      5     1.00    *                   addsubps	(%rax), %xmm2
# CHECK-NEXT:  5      8     8.00                        haddpd	%xmm0, %xmm2
# CHECK-NEXT:  6      9     9.00    *                   haddpd	(%rax), %xmm2
# CHECK-NEXT:  5      8     8.00                        haddps	%xmm0, %xmm2
# CHECK-NEXT:  6      9     9.00    *                   haddps	(%rax), %xmm2
# CHECK-NEXT:  5      8     8.00                        hsubpd	%xmm0, %xmm2
# CHECK-NEXT:  6      9     9.00    *                   hsubpd	(%rax), %xmm2
# CHECK-NEXT:  5      8     8.00                        hsubps	%xmm0, %xmm2
# CHECK-NEXT:  6      9     9.00    *                   hsubps	(%rax), %xmm2
# CHECK-NEXT:  1      3     1.50    *                   lddqu	(%rax), %xmm2
# CHECK-NEXT:  1      45    22.50                 U     monitor
# CHECK-NEXT:  1      1     1.00                        movddup	%xmm0, %xmm2
# CHECK-NEXT:  1      1     1.00    *                   movddup	(%rax), %xmm2
# CHECK-NEXT:  1      1     1.00                        movshdup	%xmm0, %xmm2
# CHECK-NEXT:  1      1     1.00    *                   movshdup	(%rax), %xmm2
# CHECK-NEXT:  1      1     1.00                        movsldup	%xmm0, %xmm2
# CHECK-NEXT:  1      1     1.00    *                   movsldup	(%rax), %xmm2
# CHECK-NEXT:  1      46    23.00   *      *      U     mwait

# CHECK:      Resources:
# CHECK-NEXT: [0]   - AtomPort0
# CHECK-NEXT: [1]   - AtomPort1

# CHECK:      Resource pressure per iteration:
# CHECK-NEXT: [0]    [1]
# CHECK-NEXT: 133.00 128.00

# CHECK:      Resource pressure by instruction:
# CHECK-NEXT: [0]    [1]    Instructions:
# CHECK-NEXT: 5.00   5.00   addsubpd	%xmm0, %xmm2
# CHECK-NEXT: 6.00   6.00   addsubpd	(%rax), %xmm2
# CHECK-NEXT:  -     1.00   addsubps	%xmm0, %xmm2
# CHECK-NEXT: 1.00   1.00   addsubps	(%rax), %xmm2
# CHECK-NEXT: 8.00   8.00   haddpd	%xmm0, %xmm2
# CHECK-NEXT: 9.00   9.00   haddpd	(%rax), %xmm2
# CHECK-NEXT: 8.00   8.00   haddps	%xmm0, %xmm2
# CHECK-NEXT: 9.00   9.00   haddps	(%rax), %xmm2
# CHECK-NEXT: 8.00   8.00   hsubpd	%xmm0, %xmm2
# CHECK-NEXT: 9.00   9.00   hsubpd	(%rax), %xmm2
# CHECK-NEXT: 8.00   8.00   hsubps	%xmm0, %xmm2
# CHECK-NEXT: 9.00   9.00   hsubps	(%rax), %xmm2
# CHECK-NEXT: 1.50   1.50   lddqu	(%rax), %xmm2
# CHECK-NEXT: 22.50  22.50  monitor
# CHECK-NEXT: 1.00    -     movddup	%xmm0, %xmm2
# CHECK-NEXT: 1.00    -     movddup	(%rax), %xmm2
# CHECK-NEXT: 1.00    -     movshdup	%xmm0, %xmm2
# CHECK-NEXT: 1.00    -     movshdup	(%rax), %xmm2
# CHECK-NEXT: 1.00    -     movsldup	%xmm0, %xmm2
# CHECK-NEXT: 1.00    -     movsldup	(%rax), %xmm2
# CHECK-NEXT: 23.00  23.00  mwait
